/* ts - socks 5 scanner
 *
 * by scut
 * thanks to avoozl for helping me out with signal coding
 */

#include <stdio.h>
#include <signal.h>
#include <setjmp.h>
#include <unistd.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/time.h>
#include <errno.h>
#include <netinet/in.h>
#include <netdb.h>

#include "socks5.h"
#include "methods.h"

#define	WAITAMOUNT	50000
#define	MAXWAIT		100		/* == 5 seconds */

void	usage(void);
void	alarmbreak(int signal);
void	(*oldintr)(int);

char	initialize_socks[] =
	"\x05\x01\x00";

int			s5s;
int			ra = 0;
struct sockaddr_in	s5srv;
int			sr = 0;
char			response[256];
int			responsept = 0;
char			sendbuf[256];
fd_set			pll;
struct timeval		timeout;

char			lgfn[128];
FILE			*lg;
int			v = 1;

char			hostname[128];
unsigned int		port = 1080;
char			startips[128];
unsigned long		startip;
char			endips[128];
unsigned long		endip;
unsigned long		rstartip;
unsigned long		rendip;
unsigned long		blockip;
int			clones;
int			clonecount = 0;
unsigned long		curip;
int			i = 0;
int			forkr;

static sigjmp_buf	alrmcatch;
int			sigst = 0;

/* clone data */
int			ippcl;

int	main(int argc, char *argv[])
{
	if ((argc < 6) || (argc > 7)) usage();
	strncpy(startips, argv[1], sizeof(startips));
	strncpy(endips, argv[2], sizeof(endips));
	port = atoi(argv[3]);
	strncpy(lgfn, argv[4], sizeof(lgfn));
	if (argv[5][0] == 'v') v = 1;
	if (argv[5][0] == 'q') v = 0;
	clones = (argc == 7) ? atoi(argv[6]) : 1;

	startip = inet_addr(startips);
	endip = inet_addr(endips);

	if ((s5s = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
		printf("error: socket call failed (%d)\n", errno);
		exit(1);
	}

	printf("socks 5 scanner\n");
	if (ntohl(startip) > ntohl(endip)) {
		printf("startip must be lower then endip\n");
		exit(1);
	}
	printf("scanning start ip....: %s\n", startips);
	printf("scanning end ip......: %s\n", endips);
	printf("scanning port........: %d\n", port);
	printf("number of clones.....: %d\n", clones);

	curip = ntohl(startip);
	ippcl = (ntohl(endip) - ntohl(startip)) / clones;
	printf("ips per clone........: %d\n", ippcl);

	startip = ntohl(startip);
	rstartip = startip;
	endip = ntohl(endip);
	forkr = 1;

	for (clonecount = 0; (clonecount <= (clones - 1)) && (forkr != 0); clonecount++) {
		startip = rstartip + clonecount;
		if (v == 1)
			printf("[%d] [%d.%d.%d.%d]-[%d.%d.%d.%d]\n", clonecount, ((startip & 0xff000000) >> 24),
				((startip & 0x00ff0000) >> 16), ((startip & 0x0000ff00) >> 8), (startip & 0x000000ff),
				((endip & 0xff000000) >> 24), ((endip & 0x00ff0000) >> 16), ((endip & 0x0000ff00) >> 8),
				(endip & 0x000000ff));
		forkr = fork();
		if (forkr == -1) {
			printf("error: fork() failed (%d)\n", errno);
		}
		curip = startip;
	}
	clonecount--;
	if (forkr != 0) {
		printf("all clones forked, quitting\n");
		exit(0);
	}

	leetone:
	oldintr = signal(SIGALRM, alarmbreak);
	for (; curip <= endip; curip += clones) {
		if (sigsetjmp(alrmcatch, 1) != 0) {
			alarm(0);
			sigst = 0;
			if (v) printf("connection timeout\n");
			close(s5s);
			curip += clones;
			if (oldintr)
				(void) signal(SIGALRM, oldintr);
			goto leetone;
		}

		if (((curip & 0xff) == 255) || ((curip & 0xff) == 0)) curip++;

		if ((s5s = socket(PF_INET, SOCK_STREAM, 0)) == -1) {
			if (v) printf("error: could not allocate socket (%d)\n", errno);
			exit(1);
		}
		s5srv.sin_family = AF_INET;
		s5srv.sin_port = htons(port);
		s5srv.sin_addr.s_addr = htonl(curip);
		sprintf(hostname, "%d.%d.%d.%d", ((curip & 0xff000000) >> 24), ((curip & 0x00ff0000) >> 16), ((curip & 0x0000ff00) >> 8), (curip & 0x000000ff));
		if (v) printf("[%02d] [%s:%d]\t", clonecount, hostname, port);
		if (clones == 1)
			fflush(stdout);

		alarm(3);
		if (connect(s5s, (struct sockaddr *)&s5srv, sizeof(s5srv)) == -1) {
			alarm(0);
			switch (errno) {
				case ECONNREFUSED:	if (v) printf("connection refused\n");
							break;
				case ENETUNREACH:	if (v) printf("network unreachable\n");
							break;
				case EHOSTUNREACH:	if (v) printf("host unreachable\n");
							break;
				default:		if (v) printf("connect error %d\n", errno);
							break;
			}
			close(s5s);
		} else {
			alarm(0);
			if (write(s5s, initialize_socks, 3) == -1) {
				if (v) printf("error: write failed (%d)\n", errno);
			} else {
				for (i = 0; i <= MAXWAIT; i++) {
					ra = read(s5s, (response + responsept), (sizeof(response) - responsept));
					if ((ra == -1) && (errno != EAGAIN)) {
						if (v) printf("error: (%d) read failed (%d)\n", s5s, errno);
						close(s5s);
					} else if (ra == 0) {
						if (v) printf("error: server closed down the network connection.\n");
						close(s5s);
					} else if (ra != -1) {
						responsept += ra;
					}
					if (responsept >= 2) {
						if (response[0] == SOCKS_VER) {
							lg = fopen(lgfn, "a+");
							if (lg == NULL) {
								if (v) printf("failed to log socks server\n");
							} else {
								fprintf(lg, "[%d.%d.%d.%d:%d] ", ((curip & 0xff000000) >> 24), ((curip & 0x00ff0000) >> 16), ((curip & 0x0000ff00) >> 8), (curip & 0x000000ff), port);
								fprintf(lg, "socks 5 server found, type ");
								switch(response[1]) {
									case R_METHOD_NOAUTH:
										fprintf(lg, "NO AUTH\n");
										break;
									case R_METHOD_GSSAPI:
										fprintf(lg, "GSSAPI\n");
										break;
									case R_METHOD_USERPW:
										fprintf(lg, "USER/PW\n");
										break;
									default:
										fprintf(lg, "NO VALID TYPE\n");
										break;
								}
								fclose(lg);
							}
						} else {
							if (v) printf("no valueable response detected.\n");
						}
						close(s5s);
						i = MAXWAIT + 1;
					}
					usleep(WAITAMOUNT);
				}
				if (i > MAXWAIT)
					if (v) printf("connection timed out.\n");
				close(s5s);
			}
		}
	}
	exit(0);
}

void	usage(void)
{
	printf("ts v.1 - socks 5 scanner by sc\n\n");
	printf("ts <startip> <endip> <port> <logfile> <mode> [clones]\n\n");
	printf("<startip>  = ip to start scanning\n");
	printf("<endip>    = ip to end scanning\n");
	printf("<port>     = port to search for socks 5 servers (usualy 1080)\n");
	printf("<logfile>  = file to log servers\n");
	printf("<mode>     = \"v\"erbose, \"q\"uiet\n");
	printf("[clones]   = number of clones to use to scan\n");
	exit(1);
}

void	alarmbreak(int signal)
{
	siglongjmp(alrmcatch, 1);
}
